import { CacheEntry } from './levelcache.classes.cacheentry';

export abstract class AbstractCache {
  public abstract ready: Promise<void>;
  public abstract status: 'active' | 'inactive';

  // Blobs
  /**
   * store a Blob
   */
  public abstract storeCacheEntryByKey(keyArg: string, valueArg: CacheEntry): Promise<void>;

  // Cache Entries
  /**
   * retrieve cache entry
   */
  public abstract retrieveCacheEntryByKey(keyArg: string): Promise<CacheEntry>;

  public abstract checkKeyPresence(keyArg: string): Promise<boolean>;

  /**
   * cleans the cache
   */
  public abstract clean(): Promise<void>;
}
